package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssimplementalstate.ElderlyAssessSimpleMentalStatePageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssimplementalstate.ElderlyAssessSimpleMentalStateRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssimplementalstate.ElderlyAssessSimpleMentalStateSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyAssessSimpleMentalStateService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 简易精神状态量表")
@RestController
@RequestMapping("/elderly-assess-simple-mental-state")
@Validated
public class ElderlyAssessSimpleMentalStateController {

    @Resource
    private ElderlyAssessSimpleMentalStateService elderlyAssessSimpleMentalStateService;

    @PostMapping("/create")
    @Operation(summary = "创建简易精神状态量表")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyAssessSimpleMentalStateSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyAssessSimpleMentalStateService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新简易精神状态量表")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyAssessSimpleMentalStateSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyAssessSimpleMentalStateService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除简易精神状态量表")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyAssessSimpleMentalStateService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得简易精神状态量表详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyAssessSimpleMentalStateRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyAssessSimpleMentalStateService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得简易精神状态量表分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyAssessSimpleMentalStateRespVO>> page(@Valid ElderlyAssessSimpleMentalStatePageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyAssessSimpleMentalStateService.getPage(pageReqVO));
    }
}
